/* To use this file, define "DEVICE" to be a macro taking four parameters
** Parm 1 is the symbol of an enumerant of the device types
** Parm 2 is the bitfield value for this device type
** Parm 3 is the string value (less "DGC") for the device.
** Parm 4 is the number of characters in the string value
**
** For example, to establish the enumerated type defining the device types:
**
** typedef enum _tagDEVICETYPES {
** #define DEVICE(w, x, y, z, i) w = y,
** #include "devices.h"
** } DEVICETYPES;
*/
DEVICE(DGCXXX,  0x00000000, "XXX",  3)
DEVICE(DGC133,  0x00000001, "133",  3)
DEVICE(DGC139,  0x00000002, "139",  3)
DEVICE(DGC144,  0x00000004, "144",  3)
DEVICE(DGC150,  0x00000008, "150",  3)
DEVICE(DGC151,  0x00000010, "151",  3)
DEVICE(DGC139S, 0x00000020, "139S", 4)
DEVICE(DGC150S, 0x00000040, "150S", 4)
DEVICE(DGC151S, 0x00000080, "151S", 4)
DEVICE(DGC153,  0x00000100, "153",  3)
DEVICE(DGC154,  0x00000200, "154",  3)
DEVICE(DGC159,  0x00000400, "159",  3)
DEVICE(DGC147,  0x00000800, "147",  3)
DEVICE(DGC161,  0x00001000, "161",  3)
DEVICE(DGC165,  0x00002000, "165",  3)
DEVICE(DGC167,  0x00004000, "167",  3)
DEVICE(DGC168,  0x00008000, "168",  3)
DEVICE(DGC169,  0x00010000, "169",  3)
// DGCRFS looks like a generic name - it's specific to DGC165.  Can't be used for future kit.
DEVICE(DGCRFS,  0x00020000, "RFS",  3)
// DGCKRN looks like a generic name - it's specific to DGC165.  Can't be used for future kit.
DEVICE(DGCKRN,  0x00040000, "KRN",  3)
DEVICE(DGC179,  0x00100000, "179",  3)
DEVICE(DGC182,  0x00200000, "182",  3)
DEVICE(DGC184,  0x00400000, "184",  3)
DEVICE(DGC183K, 0x01000000, "183K", 4) // DGC183 Kernel image.
DEVICE(DGC183R, 0x02000000, "183R", 4) // DGC183 Root Filesystem image.
DEVICE(DGC183,  0x04000000, "183",  3) // DGC183 device.
DEVICE(DGC177F, 0x10000000, "177F", 4) // DGC177 Firmware
DEVICE(DGC177,  0x20000000, "177",  3) // DGC177 RPD
DEVICE(DGC201,  0x40000000, "201",  3) // DGC201

#ifdef INCLUDE_VISIONLC
DEVICE(DGC186, 0x00800000, "186", 3)
DEVICE(DGC199, 0x08000000, "199", 3)
#endif

#undef DEVICE
