#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/timer.h>

#include "rgb_api_types.h"
#include "rgb133timer.h"

#include "rgb133debug.h"

void rgb133_init_timer(struct timer_list* pTimer)
{
   init_timer(pTimer);
}

void rgb133_setup_timer(struct timer_list* pTimer,
      void (*function)(unsigned long), unsigned long data)
{
   setup_timer(pTimer, function, data);
}

int rgb133_mod_timer(PTIMERAPI _pTimer, unsigned long expires_ms)
{
   struct timer_list* pTimer = (struct timer_list*)_pTimer;
   unsigned long expires = jiffies + msecs_to_jiffies(expires_ms);
   return mod_timer(pTimer, expires);
}

void rgb133_del_timer(struct timer_list* pTimer)
{
   del_timer(pTimer);
}

int rgb133_timer_pending(struct timer_list* pTimer)
{
   return timer_pending(pTimer);
}
